%bcond_without repolib

%define reltag %{nil}
%define namedversion %{version}%{?reltag}

%define repodir %{_javadir}/repository.jboss.com/com/google/protobuf/protobuf-java/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           protobuf-java
Version:        2.3.0
Release:        5%{?dist}
Epoch:          0
Summary:        Protocol Buffers - Google's data interchange format
License:        BSD
Group:          Development/Libraries
Source0:        http://protobuf.googlecode.com/files/protobuf-%{version}.tar.gz
Source1:        %{name}-component-info.xml
Patch0:         protobuf-java-notests.patch
URL:            http://code.google.com/p/protobuf/
Conflicts:      protobuf-compiler > %{epoch}:%{version}-%{release}
Conflicts:      protobuf-compiler < %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java-1.6.0
Requires:       jpackage-utils
#
BuildRequires:  gcc-c++
BuildRequires:  make
#
BuildRequires:  commons-parent
BuildRequires:  java-1.6.0-devel
BuildRequires:  jpackage-utils
BuildRequires:  google-parent >= 0:1
BuildRequires:  easymock2 >= 0:2.2
BuildRequires:  easymock-classextension2 >= 0:2.2.1
BuildRequires:  maven2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven-doxia-sitetools
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Protocol Buffers are a way of encoding structured data in an efficient
yet extensible format. Google uses Protocol Buffers for almost all of
its internal RPC protocols and file formats.

Protocol buffers are a flexible, efficient, automated mechanism for
serializing structured data – think XML, but smaller, faster, and
simpler. You define how you want your data to be structured once, then
you can use special generated source code to easily write and read
your structured data to and from a variety of data streams and using a
variety of languages. You can even update your data structure without
breaking deployed programs that are compiled against the "old" format.

This package contains Java Protocol Buffers runtime library.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Documentation
Requires:       jpackage-utils

%description javadoc
This package contains the API documentation for %{name}-java.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n protobuf-%{version}
%patch0 -p0 -b .sav0

%{_bindir}/iconv -f iso8859-1 -t utf-8 CONTRIBUTORS.txt > CONTRIBUTORS.txt.utf8
%{__mv} CONTRIBUTORS.txt.utf8 CONTRIBUTORS.txt

%{__rm} -r java/src/test

%build
./configure --prefix=%{_prefix}
%{__make}

pushd java
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
popd

%install
%{__rm} -rf %{buildroot}

pushd java
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p target/%{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
(cd  %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap com.google.protobuf protobuf-java %{version} JPP %{name}

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{version}-brew`
%{__sed} -i "s/@VERSION@/$tag/g"  %{buildroot}%{repodir}/component-info.xml
tag=`/binecho %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/protobuf-java.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/protobuf-java.jar
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif
popd

%post 
%update_maven_depmap

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%doc CHANGES.txt CONTRIBUTORS.txt COPYING.txt INSTALL.txt README.txt examples
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Jul 13 2011 David Walluck <dwalluck@redhat.com> 0:2.3.0-5
- rebuild

* Wed Jul 13 2011 David Walluck <dwalluck@redhat.com> 0:2.3.0-4
- fix deploy
- add examples as documentation

* Sat Jan 22 2011 David Walluck <dwalluck@redhat.com> 0:2.3.0-3
- fix javadoc copying
- fix javadoc package Requires
- fix javadoc Summary
- fix repolib
- fix java (Build)Requires
- remove protobuf-java-upload.sh

* Tue Dec 21 2010 Fernando nasser <fnasser@redhat.com> - 2.3.0-2
- Add maven contents to repolib for MEAD loading

* Fri Apr 30 2010 Permaine Cheung <pcheung@redhat.com> - 2.3.0-1
- Adapt the fedora spec file for protobuf-java specifically
- Upgrade to 2.3.0
